#!/bin/perl
#
# make_cfg.pl: Filters out all the 
# Unecessary statements from the verilog files
# except the following
# module , endmodule
# input, output, assign 
# Thus making this a CFG grammar (Context Free Grammar).
#
# vamsi.krishnak@gmail.com Apr 20, 2007
#

if($#ARGV < 0){
	die("Usage: perl filter.pl verilog.v");
}
$/ = ';';
open(VERILOG,$ARGV[0]) or die("Unable to open $ARGV[0]");
$NEW_FILE = $ARGV[0]."_new".".v";
open(OUTFILE,">$NEW_FILE") or die("Unable to open $NEW_FILE");
$mod_start = 0;
while(<VERILOG>){
	$line = $_;
	if($line =~ /(module [^;]+;)/){
		$line = $1;
		if($mod_start == 1){
			print OUTFILE "endmodule\n";
		}
		print OUTFILE "$line\n";
		$mod_start = 1;
	}elsif($line =~ /(input [^;]+;)/){
		print OUTFILE "$1\n";
	}elsif($line =~ /(output [^;]+;)/){
		print OUTFILE "$1\n";
	}elsif($line =~ /(assign [^;]+;)/){
		print OUTFILE "$1\n";
	}else{
			print "IGNORED: $line\n";
	}
}
if($mod_start == 1){
	print OUTFILE "endmodule\n";
}
close(OUTFILE);
