%{
#include "List.h"
#include "hash.h"
#include "verilog.h"
#include<string.h>
#include "y.tab.h"
#include<string.h>
#include<stdio.h>
#include<stdlib.h>
unsigned int current_line_no=1;
unsigned int current_col_no=1;
/*
 *If this is 1 indicates path finder is processing
 *a library verilog code, and in such cases
 *It just process's input and output statements
 */
extern char libmode;
%}

%x module inout nonlib assign

%%

<*>"//"[^\n]+	{
			printf("Ignoring Comment\n");
		}

<nonlib>"."		{
			current_col_no++;
			return DOT;
		}

<inout,module,nonlib>"("		{
			current_col_no++;
			return LEFT_BRACE;
		}

<inout,module,nonlib>")"		{
			current_col_no++;
			return RIGHT_BRACE;
		}

<inout,module,nonlib>","		{
			current_col_no++;
			return COMMA;
		}

<assign,nonlib>"="     {
			current_col_no++;
			return ASSIGN_OPERATOR;
	    }

<*>[a-zA-Z0-9_']+ {
	  char mesg_buffer[1024];
	   if(!strncmp(yytext,"module",6)){
		    yylval.str = "module";
		    BEGIN module;
		    return MODULE_KEY_WORD;	
	   }else if(!strncmp(yytext,"input",5)){
		   	yylval.str = "input";
		   	BEGIN inout;
			return INPUT_KEY_WORD;
	   }else if(!strncmp(yytext,"wire",4)){
		   yylval.str = "wire";
		   BEGIN inout;
		   return WIRE_KEY_WORD;
	   }else if(!strncmp(yytext,"output",6)){
		    yylval.str = "output";
			BEGIN inout;
			return OUTPUT_KEY_WORD;	   
	   }else if(!strncmp(yytext,"endmodule",9)){
		    yylval.str = "endmodule";
			BEGIN INITIAL;
			return ENDMODULE_KEY_WORD;	   
	   }else if(!strncmp(yytext,"assign",6)){
		    yylval.str = "assign";
			BEGIN assign;
			return ASSIGN_KEY_WORD;
	   }else{
		   if(!libmode){
			   BEGIN nonlib;
		   }
		   yylval.str = strdup_verilog(yytext,yyleng);
		   return IDENTIFIER;
	   }
}

<*>[\ \t]+ {}
<*>;	 {
			current_col_no++;
			return SEMI_COLON;
		 }
<*>\n	 {
			current_line_no++;
			current_col_no = 1;
		 }
%%
