%{
# include <stdio.h>
# include <string.h>
# include "sp.h"
# include "build.h"
# define	TBSIZE	2000
Cell	*topcell;
extern Cell	*makecell();
static char	tbuf[TBSIZE];
static char	*args[TBSIZE/5];
static char	**argsp;	/* end of argument list */
static char	*tbufp = tbuf;
# define	pusharg(xx)		*argsp++ = xx;\
							*argsp = (char *)0
# define	initstacks() tbufp = &tbuf[0];\
							*tbufp = (char)0;\
							argsp = &args[0];\
							*argsp=(char *)0
extern Cellinfo	cstack[];
extern Cellinfo	*cstackp;
# define	pushsubckt(xx)	++cstackp;\
							cstackp->cp = xx;\
							cstackp->elist = (Elementlist *)0;\
							cstackp->clist = (Subcktlist *)0;\
							cstackp->mlist = (Modellist *)0
# define	popsubckt()		finishcell(); --cstackp

char	*savestr(s)
char	*s;
{
	char	*t = tbufp;
	do{
		*tbufp++ = *s;
		if(tbufp == &tbuf[TBSIZE])
			yyerror("TBSIZE exceeded!");
	} while(*s++);
	return t;
}
static char	*internalnode(elementname,pinname)
char	*elementname, *pinname;
{
	static char ib[25];
	strcpy(&ib[0],elementname);
	strcat(&ib[0],pinname);
	return savestr(&ib[0]);
}
%}
%union {
	char	*p;	/* pointer */
	int		keyword;
}
%token AC
%token CONTROL
%token DATA
%token DATUM
%token DC
%token END
%token ENDS
%token EOS
%token FOUR
%token GLOBAL
%token IC	
%token LIB
%token MODEL
%token NODESET
%token NOISE
%token OP
%token OPTIONS
%token PARAM
%token PR
%token SENS
%token SUBCKT
%token TEMP
%token TF
%token TR
%token WIDTH
%token EXTENSION
%token UNKNOWN
%token INCLUDE
%type <p> datum DATUM
%type <keyword> CONTROL
%type <keyword> NOISE FOUR TF AC NODESET

%%
spice : {	initstacks();
			cstackp = &cstack[-1];
			topcell = makecell(0,&args[0], (Cell	*)0);
			pushsubckt(topcell);
		} statementlist finish { popsubckt(); return 0; }
finish: | END
statementlist :  statement
				| statementlist  statement 
statement : element eos | control eos | eos
element : subckt | primitive | model | global
global : GLOBAL optarglist { /*addtogloballist(&args[0]);*/}
elements : element eos | elements element eos 
subckt : SUBCKT datum arglist {
		Cell	*cp;
		pusharg($2);
		cp = makecell(argsp - &args[1] - 1, &args[1], cstackp->cp);
		pushsubckt(cp);
	} eos elements ENDS optarglist { popsubckt();}
control : CONTROL optarglist { control($1, &args[0]); }
model : MODEL twoterm optarglist { addmodel(&args[0]); }
optarglist : | arglist
arglist :  datum | arglist datum 
primitive :  bjt
	| cap
	| csrc
	| diode
	| ind
	| jfet
	| lvccs
	| lcccs
	| lccvs
	| lvcvs
	| mfet
	| mos
	| res
	| udrc
	| muind
	| vsrc
	| vcsw
	| tline
	| ccsw
	| xsub
bjt : case_bjt threeterm {pusharg($<p>1);} arglist { makedev(3,&args[0],
		OTHER);} 
case_bjt : 'q' | 'Q'
cap : case_cap twoterm {pusharg($<p>1);} arglist { makedev(2, &args[0],
		OTHER);} 
case_cap : 'c' | 'C'
csrc : case_csrc  twoterm {pusharg($<p>1);} arglist { makedev(2, &args[0],
		CAPACITOR);} 
case_csrc : 'i' | 'I'
diode : case_diode twoterm {
		pusharg(internalnode($<p>1,"@d"));
		pusharg($<p>1);
	} arglist { makedev(3, &args[0],OTHER);} 
case_diode : 'd' | 'D'
ind : case_ind twoterm {pusharg($<p>1);} arglist { makedev(2, &args[0]
		,OTHER);} 
case_ind : 'l' | 'L'
jfet : case_jfet threeterm {pusharg($<p>1);} arglist { makedev(3, &args[0]
		,OTHER);} 
case_jfet : 'j' | 'J'
lvccs : case_lvccs fourterm {pusharg($<p>1);} arglist { makedev(4, &args[0],
		OTHER);} 
case_lvccs : 'g' | 'G'
lvcvs : case_lvcvs fourterm {pusharg($<p>1);} arglist { makedev(4, &args[0],
		OTHER);} 
case_lvcvs : 'e' | 'E'
lccvs : case_lccvs twoterm {pusharg($<p>1);} arglist { makedev(2, &args[0]
		,OTHER);} 
case_lccvs : 'h' | 'H'
lcccs : case_lcccs twoterm {pusharg($<p>1);} arglist { makedev(2, &args[0],
		OTHER);}
case_lcccs : 'f' | 'F'
mfet : case_mfet threeterm {pusharg($<p>1);} arglist { makedev(3, &args[0],
		OTHER);} 
case_mfet : 'z' | 'Z'
case_mos : 'm' | 'M'
mos : case_mos fourterm {
# ifdef INTERNALNODES
		pusharg(internalnode($<p>1,"@s"));
		pusharg(internalnode($<p>1,"@d"));
# endif
		pusharg($<p>1);
	} arglist {
# ifdef INTERNALNODES
		makedev(6, &args[0],MOS_TRANSISTOR);
# else
		makedev(4, &args[0],MOS_TRANSISTOR);
# endif
	} 
res : case_res twoterm {pusharg($<p>1);} arglist {
	makedev(2, &args[0],RESISTOR);
	} 
case_res : 'r' | 'R'
udrc : case_udrc threeterm {pusharg($<p>1);} arglist { makedev(3, &args[0]
		,OTHER);} 
case_udrc : 'u' | 'U'
vsrc : case_vsrc twoterm
	{
		pusharg(internalnode(".", $<p>1));
		pusharg($<p>1);
	} arglist { makedev(3, &args[0],OTHER);} 
case_vsrc : 'v' | 'V'
vcsw : case_vcsw fourterm {pusharg($<p>1);} arglist {makedev(4, &args[0],
		OTHER);}
case_vcsw : 's' | 'S'
ccsw : case_ccsw twoterm {pusharg($<p>1);} arglist { makedev(2, &args[0],
		OTHER);}
case_ccsw : 'w' | 'W'
muind : case_muind {pusharg($<p>1);} arglist {makedev(0, &args[0],OTHER);}
case_muind : 'k' | 'K'
tline : case_tline fourterm {pusharg($<p>1);} arglist { makedev(4, &args[0]
		,OTHER);}
case_tline : 't' | 'T'
xsub : case_xsub arglist
		{	char	*t;
			pusharg($<p>1);
			t = argsp[-2]; argsp[-2] = argsp[-1]; argsp[-1] = t; 
			makedev(argsp - &args[0] - 2, &args[0],SUBCELL);
		} 
case_xsub : 'X' | 'x'
twoterm : datum datum
threeterm : twoterm datum 
fourterm : threeterm datum
datum : DATUM { pusharg($1);}
eos : EOS { initstacks();}
%%
