set design "b19"

foreach designName $design {

	report_version -full
	system date

	# // Test Setup (Design and Library Info.)

	read_netlist -library ../../lib/verilog/GSCLib_3.0.v -noabort
	read_netlist ../../encounter/b19_cts/b19_cts.v

	run_build_model [format "%s%s" $designName "_CHIP"]

	add_scan_enables 1 {test_se}
	add_pi_constraints 0 test_se
	
	set_drc ../b19_chip.spf
	run_drc

	# Perform TFT for LOC
	set_faults -model transition -fault_coverage 
	set_delay -nopi_changes -nopo_measures -launch_cycle system
	set_atpg -decision norandom -merge high 

	#Run ATPG
	add_faults -all
	set_patterns -internal
	run_atpg -auto

	report_summaries
	
	write_patterns [format "%s%s%s" "outputs/" $designName ".loc.bin.gz"] -compress gzip -format bin -int -rep
	write_faults [format "%s%s%s" "outputs/" $designName ".loc.faults.gz"] -all -compress gzip -rep

}

exit 
