/*
 * PathFinder: Find the path in the circuit, which 
 * switched the given gates.
 * vamsi.krishnak@gmail.com Mar 29 2007
 */
#ifndef __VERILOG_H
#define __VERILOG_H
#include "List.h"
#include "hash.h"
#include "util.h"
#include<assert.h>
#include<string.h>
#include<stdio.h>
#include<sys/types.h>
#define OUT_PIN 0
#define IN_PIN 1
#define INOUT_PIN 2
typedef List PathList; 
extern char libmode;
typedef struct _modules_ {
	HASH *nets;
	HASH *net_list;
	char *mod_name;
	char *instance_name;
	char Marked;
	unsigned int fanin;
	unsigned int fanout;
	List *fanin_nets;
	List *fanout_nets;
	List *elements;
	PathList *path_list;
	struct _modules_ *parent_cell;
}Module;

typedef struct _netlist_ {
	List *net_start;
	List *net_end;
	long size;
} NetList;

typedef struct _modules_ Element;
typedef struct _pin_pair_ {
	char *block_pin;
	char *net_pin;
}PinPair;
extern List* NewListNode();
char * strdup_verilog(char *str,size_t len);
/*Current Module Parsing variables*/
Module *current_module;
/**Declarations**/
Module* CreateNewModule(char *mod_name,List *pin_list,Module *);
Element* CreateNewElement(char *inst_name,Module *def,Module *parent_cell);
/*Parser Error Handling*/
void HandleParseError(char *err_str);
#define HOME_VAR "PATH_FINDER_HOME"
char *GetHomeDir(void);
extern char *expand_this_cell;
extern HASH *mod_def; /*Contains the definition of the modules*/
extern void FreePathsAllElements(Module *);
extern void RecursiveFindAllPaths(Element *,Element *);
extern HASH *TFaultHash;
extern FILE *TFaultFile;
extern status_t OpenTFaultFile(const char *);
extern status_t CreateTFaultHash_File(FILE *);
#endif
